vg.data.join = function() {
  var rname = null,
      as = "join",
      jointype = "inner",
      leftKey = null,
      rightKey = null,
      test = function() { return true; },
      defaultValue = null;

  function join(data, db) {
    var output = [],
        rdata = db[rname],
        rlen = rData.length,
        a, b, i, j, cnt, len, map;
    
    // if keys are specified perform a hash join
    if (leftKey && rightKey) {
      // build hash map
      for (i=0, map={}; i<rlen; ++i) {
        map[rightKey(b=rdata[i])] = b;
      }
      // iterate over values
      for (i=0, len=data.length; i<len; ++i) {
        a = data[i];
        b = map[leftKey(a)];
        if (b != null) {
          output.push(merge(a, b));
        } else if (jointype === "outer") {
          output.push(merge(left, defaultValue));
        }
      }
    // otherwise loop over both data sets
    } else {
      for (i=0, len=data.length; i<len; ++i) {
        a = data[i];
        for (j=0, cnt=0, j<rlen; ++j) {
          b = rdata[j];
          if (test(a, b, i, j)) {
            output.push(merge(left, right));
          } else if (jointype === "outer" && cnt == 0) {
            output.push(merge(left, defaultValue));
          }
        }
      }
    }
    
    return output;
  }
  
  function merge(left, right) {
    left[as] = right;
    return left;
  }

  join["with"] = function(d) {
    rname = d;
    return join;
  };
  
  join["default"] = function(d) {
    defaultValue = d;
    return join;
  };

  join.jointype = function(type) {
    jointype = type;
    return join;
  };

  join.as = function(name) {
    as = name;
    return join;
  };

  join.leftKey = function(k) {
    leftKey = vg.accessor(k);
    return join;
  };

  join.rightKey = function(k) {
    rightKey = vg.accessor(k);
    return join;
  };
  
  join.test = function(func) {
    // TODO use different parser for join predicate
    test = vg.isFunction(func) ? func : vg.parse.expr(func);
    return join;
  };

  return join;
};

vg.data.join.dependencies = ["with"];